<?php

header('Content-Type: application/json; charset=UTF-8');

// Verifique se o parâmetro 'inscricao' foi passado na URL
if (isset($_GET['inscricao'])) {
    $inscricao = $_GET['inscricao'];
    if (empty($inscricao)) {
        http_response_code(400);
        echo json_encode(['error' => 'Inscrição está vazia ou nula']);
        exit();
    }
} else {
    http_response_code(400);
    echo json_encode(['error' => 'Inscrição não fornecida']);
    exit();
}

// Obter o tipo de operação da URL (consulta ou cadastro)
$operacao = $_GET['operacao'] ?? 'consulta';

// Função para obter o token
function getToken() {
    $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/auth';
    $data = [
        'usuario' => 'PM_BA_JEQUIE',
        'senha' => '8e39d3b8-500a'
    ];

    $jsonData = json_encode($data);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

    $response = curl_exec($ch);

    if (curl_errno($ch)) {
        logMessage('Erro ao obter token: ' . curl_error($ch));
        curl_close($ch);
        return false;
    }

    curl_close($ch);

    $responseData = json_decode($response, true);

    if (json_last_error() !== JSON_ERROR_NONE || !isset($responseData['token'])) {
        logMessage('Erro ao decodificar resposta do token: ' . json_last_error_msg());
        return false;
    }

    return $responseData['token'];
}

// Obter o token
$token = getToken();
if (!$token) {
    http_response_code(500);
    echo json_encode(['error' => 'Falha ao obter token de autenticação']);
    exit();
}

// Realizar a operação solicitada
if ($operacao === 'consulta') {
    $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/consulta/inscricao';
    $data = ['inscricao_municipal' => $inscricao];
} elseif ($operacao === 'cadastro') {
    // Dados de exemplo para o cadastro, substitua conforme necessário
    $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/cadastro';
    $data = [
        'inscricao_municipal' => $inscricao,
        'proprietario' => 'Exemplo Proprietário',
        'logradouro' => 'Exemplo Logradouro',
        'bairro' => 'Exemplo Bairro',
        // Adicione outros campos necessários aqui
    ];
} else {
    http_response_code(400);
    echo json_encode(['error' => 'Operação inválida']);
    exit();
}

$jsonData = json_encode($data, JSON_UNESCAPED_UNICODE);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $token,
]);
curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

$response = curl_exec($ch);

if (curl_errno($ch)) {
    $errorMessage = curl_error($ch);
    logMessage("Erro na requisição: $errorMessage");
    echo json_encode(['error' => 'Erro na requisição: ' . $errorMessage]);
    curl_close($ch);
    exit();
}

curl_close($ch);

$responseData = json_decode($response, true);

if (json_last_error() !== JSON_ERROR_NONE) {
    logMessage("Erro ao decodificar JSON: " . json_last_error_msg());
    echo json_encode(['error' => 'Erro ao decodificar JSON: ' . json_last_error_msg()]);
    exit();
}

echo json_encode($responseData, JSON_UNESCAPED_UNICODE);

function logMessage($message) {
    file_put_contents('error_log.txt', date('Y-m-d H:i:s') . " - $message\n", FILE_APPEND);
}
?>
